//+------------------------------------------------------------------+
//|                                                          macd HL |
//|                                                           mladen |
//|                                                                  |
//| forex-tsd elite section only indicator                           |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"


#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  DeepSkyBlue
#property indicator_color2  Magenta
#property indicator_color3  LimeGreen
#property indicator_color4  LimeGreen
#property indicator_color5  Red
#property indicator_color6  Red
#property indicator_color7  DimGray
#property indicator_style4  STYLE_DOT
#property indicator_style5  STYLE_DOT
#property indicator_style7  STYLE_DOT
#property indicator_width1  2

//
//
//
//
//

extern int    FastLength     = 12;
extern int    SlowLength     = 26;
extern int    SignalLength   =  9;
extern int    ApplyTo        = PRICE_CLOSE;
extern int    LookBackLength = 50;
extern double UpEarlyLevel   = 0.25;
extern double DownEarlyLevel = 0.25;
extern bool   ShowArrows     = true;
extern color  ArrowUpColor   = Green;
extern color  ArrowDownColor = Red;

double macd[];
double macds[];
double macdhh[];
double macdhe[];
double macdll[];
double macdle[];
double macdzl[];
double trend[];

string arrowNames;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,macd);   SetIndexLabel(0,"macd");
   SetIndexBuffer(1,macds);  SetIndexLabel(1,"macd signal line");
   SetIndexBuffer(2,macdhh); SetIndexLabel(2,"macd high");
   SetIndexBuffer(3,macdhe); SetIndexLabel(3,"macd upper early");
   SetIndexBuffer(4,macdle); SetIndexLabel(4,"macd lower early");
   SetIndexBuffer(5,macdll); SetIndexLabel(5,"macd low");
   SetIndexBuffer(6,macdzl); SetIndexLabel(6,"macd zero line");
   SetIndexBuffer(7,trend);
   
   //
   //
   //
   //
   //

   if (ShowArrows)
         arrowNames = MakeUniqueName("macd HL "," (");
   else  arrowNames = "macd HL (";
   IndicatorShortName(arrowNames+FastLength+","+SlowLength+","+SignalLength+","+LookBackLength+","+DoubleToStr(UpEarlyLevel,3)+","+DoubleToStr(DownEarlyLevel,3)+")");
   return(0);
}

//
//
//
//
//

int deinit()
{
   if (ShowArrows)
   {
      int compareLength = StringLen(arrowNames);
      for (int i=ObjectsTotal(); i>= 0; i--)
      {
         string name = ObjectName(i);
            if (StringSubstr(name,0,compareLength) == arrowNames)
                ObjectDelete(name);  
      }
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,limit;
   int counted_bars=IndicatorCounted();
   if (counted_bars>0) counted_bars--;
            limit=MathMin(Bars-counted_bars,Bars-1);
 
   //
   //
   //
   //
   //
 
   double alpha = 2.0 / (1.0+SignalLength);
   for(i=limit; i>=0; i--)
   {
      macd[i] = iMA(NULL,0,FastLength,0,MODE_EMA,ApplyTo,i)-iMA(NULL,0,SlowLength,0,MODE_EMA,ApplyTo,i);
      if (i==(Bars-1))
            macds[i] = macd[i];
      else  macds[i] = macds[i+1]+alpha*(macd[i]-macds[i+1]);
      
      //
      //
      //
      //
      //
      
      double macdMax=macd[i];
      double macdMin=macd[i];
         for (int k=1; (i+k)<Bars && k<LookBackLength; k++)
         {
            macdMax = MathMax(macd[i+k],macdMax);
            macdMin = MathMin(macd[i+k],macdMin);
         }
      macdhh[i] =  macdMax;
      macdll[i] =  macdMin;
      macdzl[i] = (macdMax+macdMin)/2.0;
      macdhe[i] = macdzl[i]+(macdhh[i]-macdzl[i])*UpEarlyLevel;
      macdle[i] = macdzl[i]-(macdzl[i]-macdll[i])*DownEarlyLevel;
      
      //
      //
      //
      //
      //
      
      if (ShowArrows)
      {
         double dist = iATR(NULL,0,20,i)/2.0;
            ObjectDelete(arrowNames+Time[0]);         
            
            //
            //
            //
            //
            //
            
            trend[i] = trend[i+1];
               if (macd[i]>macds[i]) trend[i] =  1;
               if (macd[i]<macds[i]) trend[i] = -1;
               if (trend[i] !=trend[i+1])
               {
                  string name = arrowNames+Time[i];
                  if (trend[i] == 1)
                  {
                     ObjectCreate(name,OBJ_ARROW,0, Time[i],Low[i]-dist );
                        ObjectSet(name,OBJPROP_ARROWCODE,241);
                        ObjectSet(name,OBJPROP_COLOR,ArrowUpColor);
                  }
                  else
                  {
                     ObjectCreate(name,OBJ_ARROW,0, Time[i],High[i]+dist );
                        ObjectSet(name,OBJPROP_ARROWCODE,242);
                        ObjectSet(name,OBJPROP_COLOR,ArrowDownColor);
                  }
               }
      }
   }                  
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string MakeUniqueName(string first, string rest)
{
   string result = first+(MathRand()%1001)+rest;

   while (WindowFind(result)> 0)
          result = first+(MathRand()%1001)+rest;
   return(result);
}

